/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author jiri
 */
public class AlphaBeta {
    
    public static int AlphaBetaArvo(AlphaBetaSolmu solmu){
        if(solmu.onMaximiSolmu())
            return MaxArvo(solmu, -1, 1);
        else
            return MinArvo(solmu, -1, 1);
    }

    private static int MaxArvo(AlphaBetaSolmu solmu, int alpha, int beta) {
        if(solmu.onLopputila())
            return solmu.arvo();
        int value = Integer.MIN_VALUE;
        for(AlphaBetaSolmu lapsi : solmu.generoiLapset()){
            value = Math.max(value, MinArvo(lapsi, alpha, beta));
            if(value>=beta)
                return value;
            alpha = Math.max(alpha, value);
        }
        return value;
    }
    
    private static int MinArvo(AlphaBetaSolmu solmu, int alpha, int beta){
        if(solmu.onLopputila())
            return solmu.arvo();
        int value = Integer.MAX_VALUE;
        for(AlphaBetaSolmu lapsi : solmu.generoiLapset()){
            value = Math.min(value, MaxArvo(lapsi, alpha, beta));
            if(value<=alpha)
                return value;
            beta = Math.min(beta, value);
        }
        return value;
    }
    
    
}
