
import java.util.ArrayList;
import java.util.List;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author jiri
 */
public class Ristinolla implements AlphaBetaSolmu{
    public  String tila;
    public boolean ristinVuoro;

    public Ristinolla(String tila, boolean ristinVuoro) {
        this.tila = tila;
        this.ristinVuoro = ristinVuoro;
    }
    
    @Override
    public boolean onLopputila(){
        return tila.indexOf('?') < 0 || voitti('x') || voitti('o');
    }
    
   
    
    public boolean voitti(char c){
        String s = ""+c+c+c;
        return ( tila.substring(0, 3).equals(s)
         || tila.substring(3, 6).equals(s)
         || tila.substring(6, 9).equals(s)
                
         || ("" + tila.charAt(0)+tila.charAt(3)+tila.charAt(6)).equals(s)     
         || ("" + tila.charAt(1) + tila.charAt(4) + tila.charAt(7)).equals(s)    
         || ("" + tila.charAt(2) + tila.charAt(5) + tila.charAt(8)).equals(s)
                
         || ("" + tila.charAt(0)+tila.charAt(4)+tila.charAt(8)).equals(s)     
         || ("" + tila.charAt(6) + tila.charAt(4) + tila.charAt(2)).equals(s)  );
    }
    
    
    @Override
    public int arvo(){
        if(voitti('x'))
            return 1;
        else if(voitti('o'))
            return -1;
        else return 0;
    }
    
    @Override
    public ArrayList<AlphaBetaSolmu> generoiLapset(){
        ArrayList<AlphaBetaSolmu> lapset = new ArrayList<AlphaBetaSolmu>();
        int index = 0;
        
        while(true){
            int i = tila.indexOf('?', index);
            index=i+1;
            if(i<0)
                break;
            String uusiTila = tila.substring(0, i) + (ristinVuoro? 'x' : 'o');
            if(tila.length()>index)
                uusiTila += tila.substring(i+1);
            lapset.add(new Ristinolla(uusiTila, !ristinVuoro));
        }
        return lapset;      
    }

    @Override
    public String toString(){
        String ret = "";
        char[] arr = tila.toCharArray();
        for(int i=0; i<3; i++){
            for(int j=0; j<3; j++){
                ret+= "|"+arr[3*i+j];
            }
            ret +="|\n";
        }
        return ret;
    }

    @Override
    public boolean onMaximiSolmu() {
        return ristinVuoro;
    }
    
}